## This function is part of trackalyzer, by Jean-Luc Ohl
## use: trackalyzer(wavfile1,wavefilename1,wavefilepath1,wavfile2,wavefilename2,wavefilepath2,fext,fdevice)
## wavfile = wavfile to analyze, wavefilename = name on graph, wavefilepath= input and output directory for graph files
## fext = extension for graph files, default '.png', fdevice = print size
## LRA is not the same as EBU R128 tech 3342 : only absolute threshold at -70dB but no relative threshold at -20LU
## DR is not the same as TT-DR : peak is the max peak of file, not the second max
##
##

cd D:\documents\audio\trackalyzer\files\octave;
wavfile1 = 'C:\Users\jlo\Desktop\beck\04. Say Goodbye-flac44-16.wav';
wavfilename1 = "04. Say Goodbye-flac44-16.wav";
wavfilepath1 = 'C:\Users\jlo\Desktop\beck\';
emph1 = 0;
wavfile2 = 'D:\documents\audio\sons\CD-ecoutes\03. Ghetto Of My Mind.wav';
wavfilename2 = "03. Ghetto Of My Mind.wav";
wavfilepath2 = 'D:\documents\audio\sons\CD-ecoutes\';
emph2 = 0;
rmsgate = 0.000316;
fext = ".png";
fdevice = '-S1200,400';



##############################################################################	
	fflush(stdout);	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	set(0,"defaultaxesfontsize",9)
	# Set the default line width
	DLW = 1.5;
	
# Variables ####################################################################
	# Samples of bloc size for analysis, L is power of 2, 2^167 = 1.5s at 44.1kHz, L between 2^15 and 2^18. Note : R128 short term is 3s.
	L = 2^16;	
	# Spectral analysis filter
	D = [0.049922035 -0.095993537 0.050612699 -0.004408786];	C = [1 -2.494956002   2.017265875  -0.522189400];
	# Iso908 deemphasis for CD, fs 44100 only
	F = [1 -0.62786881719628784282];	E = [0.45995451989513153057 -0.08782333709141937339];

	# Set times for rmssignal (time in samples), power of 2, 2^8 = 256 samples, about 6ms at 44.1kHz.
	# this is for the short term details of the rms/peak timeline
	rmslength = 2^8;
	
	# Set variables		
	wav1Lfm = zeros(1,32768);	wav1Rfm = zeros(1,32768);	wav2Lfm = zeros(1,32768);	wav2Rfm = zeros(1,32768);
	his1L = zeros(100,1);	his1R = zeros(100,1);	his2L = zeros(100,1);	his2R = zeros(100,1);	his1 = zeros(65536,1);	his2 = zeros(65536,1);
	
#Analysis of file 1 ###############################################################################		
	[size_wav1,fs1] = wavread([wavfile1],"size")
	[wav1,fs1,bits1] = wavread([wavfile1],[1 10]);	
	bits1
	duration_wav1 = size_wav1(1,1)/fs1
	if (fs1 > 48000) L1=2*L; else L1=L; endif
	if (fs1 > 48000) rmslength1=2*rmslength; else rmslength1=rmslength; endif
	
	# Constants for spectral analysis	
	hbw = (2 ^ (0.3/ 2));	bl = 1 + round((0:(L1 - 1)) / hbw);	bu = 2 + round((0:(L1 - 1)) * hbw);	bu = min(L1 + 1,bu);	
	
	Mmax1 = floor(size_wav1(1,1)/L1);	
	val1L = zeros(5+L1/rmslength1,Mmax1);
	val1R = zeros(5+L1/rmslength1,Mmax1);	

	# check if mono or stereo file
	if  (size_wav1(1,2)==1)	B1 = 1;	else	B1 = 2;	endif	

	# Analysis of blocs of file 1
	N = 1;	M = 1;
	while (M <= Mmax1)
		wav1p = wavread([wavfile1],[N N-1+L1]);
	
		# de-emphasis
		if ( emph1 == 1) 	wav1p(:,1) = filter(E,F,wav1p(:,1)); wav1p(:,B1) = filter(E,F,wav1p(:,B1)); endif
	
		his1=his1+histc(round(wav1p(:,1) * 32768),-32768:32767)+histc(round(wav1p(:,B1) * 32768),-32768:32767);
 
		wav1L = wav1p(:, 1)';
		val1L(1,M) = M*L1/fs1;
		val1L(2,M) = min(wav1L);	val1L(3,M) = max(wav1L);
		val1L(4,M) = max(-val1L(2,M), val1L(3,M));
		wav1R = wav1p(:,B1)';
		val1R(1,M) = M*L1/fs1;
		val1R(2,M) = min(wav1R);	val1R(3,M) = max(wav1R);		
		val1R(4,M) = max(-val1R(2,M), val1R(3,M));

		rmsn = 0;
		while (rmsn<L1/rmslength1)
			val1L(6+rmsn,M) = sqrt(mean((wav1L(rmsn*rmslength1+1:(rmsn+1)*rmslength1))'.^2));
			val1R(6+rmsn,M) = sqrt(mean((wav1R(rmsn*rmslength1+1:(rmsn+1)*rmslength1))'.^2));	
			rmsn = rmsn+1;
		end
		val1L(5,M) = mean(val1L(6:5+rmsn,M));	
		val1R(5,M) = mean(val1R(6:5+rmsn,M));
		val1LR(1,M) = val1L(5,M).-val1R(5,M);
			
		wav1Lf = filter(C,D,wav1p(:,1)); 	
		sev1L = abs(fft(postpad(wav1Lf(:)',2 * L1))(1:L1));
		sev1L = cumsum([0 sev1L]);
		sev1L = (sev1L(bu) - sev1L(bl)) ./ (bu - bl);
		sev1L = sev1L.+0.0000000001;
		if (M==1) wav1Lfm = 20*log10(sev1L); else wav1Lfm = wav1Lfm .+ 20*log10(sev1L); endif
		wav1Rf = filter(C,D,wav1p(:,B1)); 	
		sev1R = abs(fft(postpad(wav1Rf(:)',2 * L1))(1:L1));
		sev1R = cumsum([0 sev1R]);
		sev1R = (sev1R(bu) - sev1R(bl)) ./ (bu - bl);
		sev1R = sev1R.+0.0000000001;		
		if (M==1) wav1Rfm = 20*log10(sev1R); else wav1Rfm = wav1Rfm .+ 20*log10(sev1R); endif
		if (floor(M/20)==M/20)	disp(".");	endif
		N = N+L1;	M=M+1;
	end
	
	vald1L = val1L(6:rows(val1L),:);
	# sort in one column and decreasing order
	valc1L = flipud(sort(reshape(vald1L,rows(vald1L)*(columns(vald1L)),1)));
	# find signal under rmsgate
	n = 1; nn=rows(valc1L);
	while n<rows(valc1L) 
		if (valc1L(n)>=rmsgate)	n=n+1;	else nn=n;	n=rows(valc1L);	endif
	end
	rmsmd1L =valc1L(1:nn);
	rmsm1L = 20*log10(mean(rmsmd1L));	cf1L = 20*log10(max(val1L(4,:)))-rmsm1L;
	
	vald1R = val1R(6:rows(val1R),:);
	valc1R = flipud(sort(reshape(vald1R,rows(vald1R)*(columns(vald1R)),1)));
	n = 1; nn=rows(valc1R);
	while n<rows(valc1R) 
		if (valc1R(n)>=rmsgate)	n=n+1;	else nn=n;	n=rows(valc1R);	endif
	end
	rmsmd1R =valc1R(1:nn);	
	rmsm1R = 20*log10(mean(rmsmd1R));	cf1R = 20*log10(max(val1R(4,:)))-rmsm1R;
	
	rmsn = 0;
	while (rmsn<L1/rmslength1)	
		his1L = his1L.+histc(20*log10(val1L(6+rmsn,:)'),-99:1:0);
		his1R = his1R.+histc(20*log10(val1R(6+rmsn,:)'),-99:1:0);	
		rmsn = rmsn+1;
	end	
		
#Analysis of file 2 ###############################################################################	
	[size_wav2,fs2] = wavread([wavfile2],"size")
	[wav2,fs2,bits2] = wavread([wavfile2],[1 10]);	
	bits2
	duration_wav2 = size_wav2(1,1)/fs2
	if (fs2 > 48000) L2=2*L; else L2=L; endif
	if (fs2 > 48000) rmslength2=2*rmslength; else rmslength2=rmslength; endif
	
	# Constants for spectral analysis	
	hbw = (2 ^ (0.3/ 2));	bl = 1 + round((0:(L2 - 1)) / hbw);	bu = 2 + round((0:(L2 - 1)) * hbw);	bu = min(L2 + 1,bu);	
	
	Mmax2 = floor(size_wav2(1,1)/L2);
	val2L = zeros(5+L2/rmslength2,Mmax2);
	val2R = zeros(5+L2/rmslength2,Mmax2);	

	if  (size_wav2(1,2)==1)	B2 = 1;	else	B2 = 2;	endif		

	# Analysis of blocs of file 2		
	N = 1;	M = 1;	
	
	while (M <= Mmax2)
	wav2p = wavread([wavfile2],[N N-1+L2]);
	if ( emph2 == 1) 	wav2p(:,1) = filter(E,F,wav2p(:,1)); wav2p(:,B2) = filter(E,F,wav2p(:,B2)); endif	
	his2=his2+histc(round(wav2p(:,1) * 32768),-32768:32767)+histc(round(wav2p(:,B2) * 32768),-32768:32767);	
 
	wav2L = wav2p(:, 1)';
	val2L(1,M) = M*L2/fs2;
	val2L(2,M) = min(wav2L);	val2L(3,M) = max(wav2L);
	val2L(4,M) = max(-val2L(2,M), val2L(3,M));
	wav2R = wav2p(:,B2)';
	val2R(1,M) = M*L2/fs2;
	val2R(2,M) = min(wav2R);	val2R(3,M) = max(wav2R);		
	val2R(4,M) = max(-val2R(2,M), val2R(3,M));
 
	rmsn = 0;
	while (rmsn<L2/rmslength2)
	val2L(6+rmsn,M) = sqrt(mean((wav2L(rmsn*rmslength2+1:(rmsn+1)*rmslength2))'.^2));
	val2R(6+rmsn,M) = sqrt(mean((wav2R(rmsn*rmslength2+1:(rmsn+1)*rmslength2))'.^2));	
	rmsn = rmsn+1;
	end
	val2L(5,M) = mean(val2L(6:5+rmsn,M));	
	val2R(5,M) = mean(val2R(6:5+rmsn,M));
	val2LR(1,M) = val2L(5,M).-val2R(5,M);	
	
	wav2Lf = filter(C,D,wav2p(:,1)); 	
	sev2L = abs(fft(postpad(wav2Lf(:)',2 * L2))(1:L2));
	sev2L = cumsum([0 sev2L]);
	sev2L = (sev2L(bu) - sev2L(bl)) ./ (bu - bl);
	# in case of silence, add a small value to avoid log10(0)
	sev2L = sev2L.+0.0000000001;	
	if (M==1) wav2Lfm = 20*log10(sev2L); else wav2Lfm = wav2Lfm .+ 20*log10(sev2L); endif
	wav2Rf = filter(C,D,wav2p(:,B2)); 	
	sev2R = abs(fft(postpad(wav2Rf(:)',2 * L2))(1:L2));
	sev2R = cumsum([0 sev2R]);
	sev2R = (sev2R(bu) - sev2R(bl)) ./ (bu - bl);
	sev2R = sev2R.+0.0000000001;	
	if (M==1) wav2Rfm = 20*log10(sev2R); else wav2Rfm = wav2Rfm .+ 20*log10(sev2R); endif
	if (floor(M/20)==M/20)	disp(".");	endif
	N = N+L2;	M=M+1;
	end

	vald2L = val2L(6:rows(val2L),:);
	valc2L = flipud(sort(reshape(vald2L,rows(vald2L)*(columns(vald2L)),1)));
	n = 1; nn=rows(valc2L);
	while n<rows(valc2L) 
		if (valc2L(n)>=rmsgate)	n=n+1;	else nn=n;	n=rows(valc2L);	endif
	end
	rmsmd2L =valc2L(1:nn);
	rmsm2L = 20*log10(mean(rmsmd2L));	cf2L = 20*log10(max(val2L(4,:)))-rmsm2L;
	
	vald2R = val2R(6:rows(val2R),:);
	valc2R = flipud(sort(reshape(vald2R,rows(vald2R)*(columns(vald2R)),1)));
	n = 1; nn=rows(valc2R);
	while n<rows(valc2R) 
		if (valc2R(n)>=rmsgate)	n=n+1;	else nn=n;	n=rows(valc2R);	endif
	end
	rmsmd2R =valc2R(1:nn);	
	rmsm2R = 20*log10(mean(rmsmd2R));	cf2R = 20*log10(max(val2R(4,:)))-rmsm2R;	
		
	rmsn = 0;
	while (rmsn<L2/rmslength2)	
		his2L = his2L.+histc(20*log10(val2L(6+rmsn,:)'),-99:1:0);
		his2R = his2R.+histc(20*log10(val2R(6+rmsn,:)'),-99:1:0);	
		rmsn = rmsn+1;
	end
	
###################################################################
	disp("peak + rms, time in s");
	
	subplot(2,4,1);	hold("on");	grid("on");		title("peak + rms + (L-R), time in s");
	axis([1, max(val1L(1,:)), -50, 0]);	axis("label[x]");	safetics("y",[-50,-40,-30,-20,-10,0]);
	plot(val1R(1,:),20*log10(val1R(4,:)),["2;" ";"],"LineWidth",DLW);	
	plot(val1R(1,:),20*log10(val1R(5,:)),["2;" ";"],"LineWidth",DLW);	
	plot(val1L(1,:),20*log10(val1L(4,:)),["3;" ";"],"LineWidth",DLW);
	plot(val1L(1,:),20*log10(val1L(5,:)),["3;" ";"],"LineWidth",DLW);
	plot(val1L(1,:),20*log10(val1LR(1,:)),["4;" ";"],"LineWidth",DLW);
	
	hold("off");	
	
	subplot(2,4,5);	hold("on");	grid("on");	
	axis([1, max(val2R(1,:)), -50, 0]);	axis("label[x]");	safetics("y",[-50,-40,-30,-20,-10,0]);	
	plot(val2R(1,:),20*log10(val2R(4,:)),["4;" ";"],"LineWidth",DLW);	
	plot(val2R(1,:),20*log10(val2R(5,:)),["4;" ";"],"LineWidth",DLW);		
	plot(val2R(1,:),20*log10(val2L(4,:)),["1;" ";"],"LineWidth",DLW);
	plot(val2R(1,:),20*log10(val2L(5,:)),["1;" ";"],"LineWidth",DLW);
	plot(val2L(1,:),20*log10(val2LR(1,:)),["2;" ";"],"LineWidth",DLW);	
	hold("off");	

####################################################################	
	disp("L+R level histogram");
	
	subplot(2,4,2); hold("on");	title("L+R level histogram");
 	xax=-32768:32767;
	semilogy(xax/32768, max(his1./(L1*Mmax1),1e-10),"LineWidth",DLW);
	axis([-1.15, 1.15, 1e-7, 1e-1])
	text (-0.6, 0.03, ["Peak % L -" num2str(-100*min(val1L(2,:)),3) " +" num2str(100*max(val1L(3,:)),3)],'color','blue');
	text (-0.6, 0.007, ["Peak % R -" num2str(-100*min(val1R(2,:)),3) " +" num2str(100*max(val1R(3,:)),3)],'color','green');	
	hold("off");
	
	subplot(2,4,6); hold("on");
	xax=-32768:32767;
	semilogy(xax/32768, max(his2./(L2*Mmax2),1e-10),'color','red',"LineWidth",DLW);
	axis([-1.15, 1.15, 1e-7, 1e-1]);	
	text (-0.6, 0.03, ["Peak % L -" num2str(-100*min(val2L(2,:)),3) " +" num2str(100*max(val2L(3,:)),3)],'color','red');
	text (-0.6, 0.007, ["Peak % R -" num2str(-100*min(val2R(2,:)),3) " +" num2str(100*max(val2R(3,:)),3)],'color','magenta');
	hold("off");
	
############################################################	
	disp("Rms amplitude histogram...");
	col1 = [-99:1:0].';
	his1L = [col1 his1L]; 	his1R = [col1 his1R];	his2L = [col1 his2L];	his2R = [col1 his2R];

# measure 1L DR, 80% highest	
	DRm1 = 1;	DRc = 0;
	DRch = cumsum(his1L);
	his1L(:,2) = his1L(:,2)/DRch(rows(DRch),2);
	his1L(:,2) = his1L(:,2)/max(his1L(:,2));
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2)*0.8) DRc = DRch(DRm1,2); DRm1 = DRm1 + 1; end
	DR1L = 99-DRm1+max(val1L(4,:));

# measure 1L LRA 10% lowest, above -70dB		
	DRm1 = 30;	DRc = 0;
	his1Ld = his1L;
	his1Ld(1:30) = 0;		
	DRch = cumsum(his1Ld);
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2)*0.1) DRc = DRch(DRm1,2); DRm1 = DRm1 + 1; end
	LRAl1L = 99-DRm1+max(val1L(4,:));

# measure 1L LRA 95% highest, above -70dB	
	DRm1 = 30;	DRc = 0;
	DRch = cumsum(his1L);
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2)*0.95) DRc = DRch(DRm1,2); DRm1 = DRm1 + 1; end
	LRAh1L = 99-DRm1+max(val1L(4,:));
	LRA1L = LRAl1L - LRAh1L;

# measure 1R DR, 80% highest		
	DRm1 = 1;	DRc = 0;
	DRch = cumsum(his1R);
	his1R(:,2) = his1R(:,2)/DRch(rows(DRch),2);
	his1R(:,2) = his1R(:,2)/max(his1R(:,2));	
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2)*0.8)	DRc = DRch(DRm1,2);	DRm1 = DRm1 + 1; end
	DR1R = 99-DRm1+max(val1R(4,:))-1;	
	DR1 = round((DR1L+DR1R)/2);

# measure 1R LRA 10% lowest, above -70dB		
	DRm1 = 30;	DRc = 0;
	his1Rd = his1R;
	his1Rd(1:30) = 0;		
	DRch = cumsum(his1Rd);
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2).*0.1) DRc = DRch(DRm1,2); DRm1 = DRm1 + 1; end
	LRAl1R = 99-DRm1+max(val1R(4,:));

# measure 1R LRA 95% highest	
	DRm1 = 30;	DRc = 0;
	DRch = cumsum(his1R);
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2).*0.95) DRc = DRch(DRm1,2); DRm1 = DRm1 + 1; end
	LRAh1R = 99-DRm1+max(val1R(4,:));
	LRA1R = LRAl1R - LRAh1R;
	LRA1 = round((LRA1L+LRA1R)/2);
	
# measure 2L DR, 80% highest		
	DRm1 = 1;	DRc = 0;
	DRch = cumsum(his2L);
	his2L(:,2) = his2L(:,2)/DRch(rows(DRch),2);	
	his2L(:,2) = his2L(:,2)/max(his2L(:,2));	
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2)*0.8)	DRc = DRch(DRm1,2);	DRm1 = DRm1 + 1;	end
	DR2L = 99-DRm1+max(val2L(4,:));

# measure 2L LRA 10% lowest, above -70dB		
	DRm1 = 30;	DRc = 0;
	his2Ld = his2L;
	his2Ld(1:30) = 0;	
	DRch = cumsum(his2Ld);
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2)*0.1) DRc = DRch(DRm1,2); DRm1 = DRm1 + 1; end
	LRAl2L = 99-DRm1+max(val2L(4,:));

# measure 2L LRA 95% highest	
	DRm1 = 30;	DRc = 0;
	DRch = cumsum(his2L);
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2)*0.95) DRc = DRch(DRm1,2); DRm1 = DRm1 + 1; end
	LRAh2L = 99-DRm1+max(val2L(4,:));
	LRA2L = LRAl2L - LRAh2L;

# measure 2R DR, 80% highest		
	DRm1 = 1;	DRc = 0;
	DRch = cumsum(his2R);
	his2R(:,2) = his2R(:,2)/DRch(rows(DRch),2);
	his2R(:,2) = his2R(:,2)/max(his2R(:,2));	
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2)*0.8)	DRc = DRch(DRm1,2);	DRm1 = DRm1 + 1;	end
	DR2R = 99-DRm1+max(val2R(4,:))-1;	
	DR2 = round((DR2L+DR2R)/2);

# measure 2R LRA 10% lowest, above -70dB		
	DRm1 = 30;	DRc = 0;
	his2Rd = his2R;
	his2Rd(1:30) = 0;
	DRch = cumsum(his2Rd);
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2).*0.1) DRc = DRch(DRm1,2); DRm1 = DRm1 + 1; end
	LRAl2R = 99-DRm1+max(val2R(4,:));

# measure 2R LRA 95% highest	
	DRm1 = 30;	DRc = 0;
	DRch = cumsum(his2R);
	DRch = [col1 DRch(:,2)];
	while (DRc <=  DRch(100,2)*0.95) DRc = DRch(DRm1,2); DRm1 = DRm1 + 1; end
	LRAh2R = 99-DRm1+max(val2R(4,:));
	LRA2R = LRAl2R - LRAh2R;
	LRA2 = round((LRA2L+LRA2R)/2);
	
	subplot(2,4,3);	hold("on");	grid("on"); 	title(["rms histogram"]);
	plot(his1R(:,1),his1R(:,2),["2;" ";"],"LineWidth",DLW);	
	plot(his1L(:,1),his1L(:,2),["3;" ";"],"LineWidth",DLW);	
	axis("label[x]");	axis([-70, 0, 0, 1]); 	safetics("x",[-70,-60,-50,-40,-30,-20,-10,0]); safetics("y",[0,0.1,1]);	
	hold("off");	

	subplot(2,4,7);	hold("on");	grid("on");
	plot(his2R(:,1),his2R(:,2),["4;" ";"],"LineWidth",DLW);
	plot(his2L(:,1),his2L(:,2),["1;" ";"],"LineWidth",DLW);	
	axis("label[x]");	axis([-70, 0, 0, 1]);	safetics("x",[-70,-60,-50,-40,-30,-20,-10,0]); safetics("y",[0,0.1,1]);	
	hold("off");

#values ##############################################
	subplot(2,4,4);	hold("on");		grid("off");	axis([0, 1, 0, 1]);	axis("off");	
	text (-0.15, 1, ["1 " wavfilename1 ],'color','blue');
	text (-0.15, 0.9, ["  " num2str(floor(size_wav1(1,1)/(60*fs1))) "mn" num2str(round(size_wav1(1,1)/(fs1)-60*floor(size_wav1(1,1)/(60*fs1)))) "s  " num2str(fs1) "Hz  " num2str(bits1) "bit" ],'color','blue');	
	text (-0.15, 0.8, ["2 " wavfilename2 ],'color','red');
	text (-0.15, 0.7, ["  " num2str(floor(size_wav2(1,1)/(60*fs2))) "mn" num2str(round(size_wav2(1,1)/(fs2)-60*floor(size_wav2(1,1)/(60*fs2)))) "s  " num2str(fs2) "Hz  " num2str(bits2) "bit" ],'color','red');	
	text (-0.15, 0.53, ["    peak      rms     crestf  LRA*  DR*"]);

	text (-0.15, 0.4, ["1L  " num2str(min(0,round(100*log10(max(val1L(4,:))))/5),3) "dB"],'color','blue');
	text (0.2, 0.4, [num2str(rmsm1L,3) "dB"],'color','blue');
	text (0.5, 0.4, [num2str(cf1L,3) "dB"],'color','blue');
	text (0.75, 0.4, [num2str(LRA1,2)],'color','blue');
	text (0.9, 0.4, [num2str(DR1)],'color','blue');	
	
	text (-0.15, 0.3, ["1R  " num2str(min(0,round(100*log10(max(val1R(4,:))))/5),3) "dB"],'color','green');
	text (0.2, 0.3, [num2str(rmsm1R,3) "dB"],'color','green');
	text (0.5, 0.3, [num2str(cf1R,3) "dB"],'color','green');
	
	text (-0.15, 0.1, ["2L  " num2str(min(0,round(100*log10(max(val2L(4,:))))/5),3) "dB"],'color','red');
	text (0.2, 0.1, [num2str(rmsm2L,3) "dB"],'color','red');
	text (0.5, 0.1, [num2str(cf2L,3) "dB"],'color','red');
	text (0.75, 0.1, [num2str(LRA2,2)],'color','red');
	text (0.9, 0.1, [num2str(DR2)],'color','red');		
	
	text (-0.15, 0.0, ["2R  " num2str(min(0,round(100*log10(max(val2R(4,:))))/5),3) "dB"],'color','magenta');
	text (0.2, 0.0, [num2str(rmsm2R,3) "dB"],'color','magenta');
	text (0.5, 0.0, [num2str(cf2R,3) "dB"],'color','magenta');

	hold("off");	
	
######################################################
	disp("spectrum with 1/f correction +3dB/oct");

	wav1Rfm = wav1Rfm/Mmax1;
	wav1Lfm = wav1Lfm/Mmax1;
	wav2Rfm = wav2Rfm/Mmax2;	
	wav2Lfm = wav2Lfm/Mmax2;
	
	subplot(2,4,8);	hold("on");	grid("on");	title("spectrum with 1/f correction +3dB/oct");
	axis([0.01, 23, -21, 21]);	safetics("x",[0.02,0.05,0.1,0.2,0.5,1,2,5,10,20]);	safetics("y",-20:5:20);
	ixg= [1:columns(wav1Rfm)];
	# align plots at mid frequencies
	semilogx(ixg*fs1/(2000*columns(wav1Rfm)), wav1Rfm-mean(wav1Rfm(1,round(columns(wav1Rfm)/50):round(columns(wav1Rfm)/10))),["2;" ";"],"LineWidth",DLW);	
	semilogx(ixg*fs1/(2000*columns(wav1Lfm)), wav1Lfm-mean(wav1Lfm(1,round(columns(wav1Lfm)/50):round(columns(wav1Lfm)/10))),["3;" ";"],"LineWidth",DLW);
	ixg= [1:columns(wav2Rfm)];
	semilogx(ixg*fs2/(2000*columns(wav2Rfm)), wav2Rfm-mean(wav2Rfm(1,round(columns(wav2Rfm)/50):round(columns(wav2Rfm)/10))),["4;" ";"],"LineWidth",DLW);
	semilogx(ixg*fs2/(2000*columns(wav2Lfm)), wav2Lfm-mean(wav2Lfm(1,round(columns(wav2Lfm)/50):round(columns(wav2Lfm)/10))),["1;" ";"],"LineWidth",DLW);
	hold("off");
	
	# Print to the output file
	print([wavfilepath1 wavfilename1 "-" wavfilename2 fext ],fdevice);
	# Report the stage
	disp("Completed !");
	fflush(stdout);